Index: XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp	(revision 1642)
@@ -12,14 +12,6 @@
 
 #include "mapper.hpp"
-using namespace ep_lib;
 
 namespace sphereRemap {
-
-extern CRemapGrid srcGrid;
-#pragma omp threadprivate(srcGrid)
-
-extern CRemapGrid tgtGrid;
-#pragma omp threadprivate(tgtGrid)
-
 
 /* A subdivition of an array into N sub-arays
@@ -35,11 +27,11 @@
 
 
-void Mapper::setSourceMesh(const double* boundsLon, const double* boundsLat, int nVertex, int nbCells, const double* pole, const long int* globalId)
+void Mapper::setSourceMesh(const double* boundsLon, const double* boundsLat, const double* area, int nVertex, int nbCells, const double* pole, const long int* globalId)
 {
   srcGrid.pole = Coord(pole[0], pole[1], pole[2]);
 
   int mpiRank, mpiSize;
-  MPI_Comm_rank(communicator, &mpiRank);
-  MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
 
   sourceElements.reserve(nbCells);
@@ -51,5 +43,5 @@
     long int offset ;
     long int nb=nbCells ;
-    MPI_Scan(&nb,&offset,1,MPI_LONG,MPI_SUM,communicator) ;
+    ep_lib::MPI_Scan(&nb,&offset,1,EP_LONG,EP_SUM,communicator) ;
     offset=offset-nb ;
     for(int i=0;i<nbCells;i++) sourceGlobalId[i]=offset+i ;
@@ -67,15 +59,17 @@
     sourceMesh.push_back(Node(elt.x, cptRadius(elt), &sourceElements.back()));
     cptEltGeom(sourceElements[i], Coord(pole[0], pole[1], pole[2]));
-  }
-
-}
-
-void Mapper::setTargetMesh(const double* boundsLon, const double* boundsLat, int nVertex, int nbCells, const double* pole, const long int* globalId)
+    if (area!=NULL) sourceElements[i].given_area=area[i] ;
+    else sourceElements[i].given_area=sourceElements[i].area ;
+  }
+
+}
+
+void Mapper::setTargetMesh(const double* boundsLon, const double* boundsLat, const double* area, int nVertex, int nbCells, const double* pole, const long int* globalId)
 {
   tgtGrid.pole = Coord(pole[0], pole[1], pole[2]);
 
   int mpiRank, mpiSize;
-  MPI_Comm_rank(communicator, &mpiRank);
-  MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
 
   targetElements.reserve(nbCells);
@@ -87,5 +81,5 @@
     long int offset ;
     long int nb=nbCells ;
-    MPI_Scan(&nb,&offset,1,MPI_LONG,MPI_SUM,communicator) ;
+    ep_lib::MPI_Scan(&nb,&offset,1,EP_LONG,EP_SUM,communicator) ;
     offset=offset-nb ;
     for(int i=0;i<nbCells;i++) targetGlobalId[i]=offset+i ;
@@ -100,4 +94,6 @@
     targetMesh.push_back(Node(elt.x, cptRadius(elt), &sourceElements.back()));
     cptEltGeom(targetElements[i], Coord(pole[0], pole[1], pole[2]));
+    if (area!=NULL) targetElements[i].given_area=area[i] ;
+    else targetElements[i].given_area=targetElements[i].area ;
   }
 
@@ -121,6 +117,6 @@
   vector<double> timings;
   int mpiSize, mpiRank;
-  MPI_Comm_size(communicator, &mpiSize);
-  MPI_Comm_rank(communicator, &mpiRank);
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
 
   this->buildSSTree(sourceMesh, targetMesh);
@@ -132,6 +128,5 @@
 
   tic = cputime();
-  if (interpOrder == 2) 
-  {
+  if (interpOrder == 2) {
     if (mpiRank == 0 && verbose) cout << "Computing grads ..." << endl;
     buildMeshTopology();
@@ -142,5 +137,5 @@
   /* Prepare computation of weights */
   /* compute number of intersections which for the first order case
-     corresponds to the number of edges in the remap matrix */
+           corresponds to the number of edges in the remap matrix */
   int nIntersections = 0;
   for (int j = 0; j < targetElements.size(); j++)
@@ -178,6 +173,6 @@
 {
   int mpiSize, mpiRank;
-  MPI_Comm_size(communicator, &mpiSize);
-  MPI_Comm_rank(communicator, &mpiRank);
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
 
   /* create list of intersections (super mesh elements) for each rank */
@@ -187,7 +182,5 @@
     Elt& e = elements[j];
     for (list<Polyg *>::iterator it = e.is.begin(); it != e.is.end(); it++)
-    {
       elementList[(*it)->id.rank].insert(pair<int, Polyg *>((*it)->id.ind, *it));
-    }
   }
 
@@ -196,4 +189,5 @@
   double **recvValue = new double*[mpiSize];
   double **recvArea = new double*[mpiSize];
+  double **recvGivenArea = new double*[mpiSize];
   Coord **recvGrad = new Coord*[mpiSize];
   GloId **recvNeighIds = new GloId*[mpiSize]; /* ids of the of the source neighbours which also contribute through gradient */
@@ -218,4 +212,5 @@
       recvValue[rank]   = new double[nbSendElement[rank]];
       recvArea[rank]    = new double[nbSendElement[rank]];
+      recvGivenArea[rank] = new double[nbSendElement[rank]];
       if (order == 2)
       {
@@ -240,6 +235,5 @@
   /* communicate sizes of source elements to be sent (index lists and later values and gradients) */
   int *nbRecvElement = new int[mpiSize];
-  MPI_Alltoall(nbSendElement, 1, MPI_INT, nbRecvElement, 1, MPI_INT, communicator);
-  
+  ep_lib::MPI_Alltoall(nbSendElement, 1, EP_INT, nbRecvElement, 1, EP_INT, communicator);
 
   /* communicate indices of source elements on other ranks whoes value and gradient we need (since intersection) */
@@ -249,13 +243,14 @@
   double **sendValue = new double*[mpiSize];
   double **sendArea = new double*[mpiSize];
+  double **sendGivenArea = new double*[mpiSize];
   Coord **sendGrad = new Coord*[mpiSize];
   GloId **sendNeighIds = new GloId*[mpiSize];
-  MPI_Request *sendRequest = new MPI_Request[4*mpiSize];
-  MPI_Request *recvRequest = new MPI_Request[4*mpiSize];
+  ep_lib::MPI_Request *sendRequest = new ep_lib::MPI_Request[5*mpiSize];
+  ep_lib::MPI_Request *recvRequest = new ep_lib::MPI_Request[5*mpiSize];
   for (int rank = 0; rank < mpiSize; rank++)
   {
     if (nbSendElement[rank] > 0)
     {
-      MPI_Issend(sendElement[rank], nbSendElement[rank], MPI_INT, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      ep_lib::MPI_Issend(sendElement[rank], nbSendElement[rank], EP_INT, rank, 0, communicator, &sendRequest[nbSendRequest]);
       nbSendRequest++;
     }
@@ -266,4 +261,5 @@
       sendValue[rank]   = new double[nbRecvElement[rank]];
       sendArea[rank]   = new double[nbRecvElement[rank]];
+      sendGivenArea[rank] = new double[nbRecvElement[rank]];
       if (order == 2)
       {
@@ -275,12 +271,12 @@
         sendNeighIds[rank] = new GloId[nbRecvElement[rank]];
       }
-      MPI_Irecv(recvElement[rank], nbRecvElement[rank], MPI_INT, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      ep_lib::MPI_Irecv(recvElement[rank], nbRecvElement[rank], EP_INT, rank, 0, communicator, &recvRequest[nbRecvRequest]);
       nbRecvRequest++;
     }
   }
-  MPI_Status *status = new MPI_Status[4*mpiSize];
-
-  MPI_Waitall(nbSendRequest, sendRequest, status);
-  MPI_Waitall(nbRecvRequest, recvRequest, status);
+  ep_lib::MPI_Status *status = new ep_lib::MPI_Status[5*mpiSize];
+  
+  ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+        ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
 
   /* for all indices that have been received from requesting ranks: pack values and gradients, then send */
@@ -296,7 +292,9 @@
         sendValue[rank][j] = sstree.localElements[recvElement[rank][j]].val;
         sendArea[rank][j] = sstree.localElements[recvElement[rank][j]].area;
+        sendGivenArea[rank][j] = sstree.localElements[recvElement[rank][j]].given_area;
         if (order == 2)
         {
           sendGrad[rank][jj] = sstree.localElements[recvElement[rank][j]].grad;
+//          cout<<"grad  "<<jj<<"  "<<recvElement[rank][j]<<"  "<<sendGrad[rank][jj]<<" "<<sstree.localElements[recvElement[rank][j]].grad<<endl ;
           sendNeighIds[rank][jj] = sstree.localElements[recvElement[rank][j]].src_id;
           jj++;
@@ -304,61 +302,65 @@
           {
             sendGrad[rank][jj] = sstree.localElements[recvElement[rank][j]].gradNeigh[i];
+//            cout<<"grad  "<<jj<<"  "<<sendGrad[rank][jj]<<" "<<sstree.localElements[recvElement[rank][j]].grad<<endl ;
             sendNeighIds[rank][jj] = sstree.localElements[recvElement[rank][j]].neighId[i];
-						jj++;
-					}
-				}
-				else
-					sendNeighIds[rank][j] = sstree.localElements[recvElement[rank][j]].src_id;
-			}
-			MPI_Issend(sendValue[rank],  nbRecvElement[rank], MPI_DOUBLE, rank, 0, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-			MPI_Issend(sendArea[rank],  nbRecvElement[rank], MPI_DOUBLE, rank, 1, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-			if (order == 2)
-			{
-				MPI_Issend(sendGrad[rank], 3*nbRecvElement[rank]*(NMAX+1),
-								MPI_DOUBLE, rank, 2, communicator, &sendRequest[nbSendRequest]);
-				nbSendRequest++;
-				MPI_Issend(sendNeighIds[rank], 4*nbRecvElement[rank]*(NMAX+1), MPI_INT, rank, 3, communicator, &sendRequest[nbSendRequest]);
+            jj++;
+          }
+        }
+        else
+          sendNeighIds[rank][j] = sstree.localElements[recvElement[rank][j]].src_id;
+      }
+      ep_lib::MPI_Issend(sendValue[rank],  nbRecvElement[rank], EP_DOUBLE, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+      ep_lib::MPI_Issend(sendArea[rank],  nbRecvElement[rank], EP_DOUBLE, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+      ep_lib::MPI_Issend(sendGivenArea[rank],  nbRecvElement[rank], EP_DOUBLE, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+      if (order == 2)
+      {
+        ep_lib::MPI_Issend(sendGrad[rank], 3*nbRecvElement[rank]*(NMAX+1), EP_DOUBLE, rank, 0, communicator, &sendRequest[nbSendRequest]);
+        nbSendRequest++;
+        ep_lib::MPI_Issend(sendNeighIds[rank], 4*nbRecvElement[rank]*(NMAX+1), EP_INT, rank, 0, communicator, &sendRequest[nbSendRequest]);
 //ym  --> attention taille GloId
-				nbSendRequest++;
-			}
-			else
-			{
-				MPI_Issend(sendNeighIds[rank], 4*nbRecvElement[rank], MPI_INT, rank, 4, communicator, &sendRequest[nbSendRequest]);
+        nbSendRequest++;
+      }
+      else
+      {
+        ep_lib::MPI_Issend(sendNeighIds[rank], 4*nbRecvElement[rank], EP_INT, rank, 0, communicator, &sendRequest[nbSendRequest]);
 //ym  --> attention taille GloId
-				nbSendRequest++;
-			}
-		}
-		if (nbSendElement[rank] > 0)
-		{
-			MPI_Irecv(recvValue[rank],  nbSendElement[rank], MPI_DOUBLE, rank, 0, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-			MPI_Irecv(recvArea[rank],  nbSendElement[rank], MPI_DOUBLE, rank, 1, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-			if (order == 2)
-			{
-				MPI_Irecv(recvGrad[rank], 3*nbSendElement[rank]*(NMAX+1),
-						MPI_DOUBLE, rank, 2, communicator, &recvRequest[nbRecvRequest]);
-				nbRecvRequest++;
-				MPI_Irecv(recvNeighIds[rank], 4*nbSendElement[rank]*(NMAX+1), MPI_INT, rank, 3, communicator, &recvRequest[nbRecvRequest]);
-//ym  --> attention taille GloId
-				nbRecvRequest++;
-			}
-			else
-			{
-				MPI_Irecv(recvNeighIds[rank], 4*nbSendElement[rank], MPI_INT, rank, 4, communicator, &recvRequest[nbRecvRequest]);
+        nbSendRequest++;
+      }
+    }
+    if (nbSendElement[rank] > 0)
+    {
+      ep_lib::MPI_Irecv(recvValue[rank],  nbSendElement[rank], EP_DOUBLE, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+      ep_lib::MPI_Irecv(recvArea[rank],  nbSendElement[rank], EP_DOUBLE, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+      ep_lib::MPI_Irecv(recvGivenArea[rank],  nbSendElement[rank], EP_DOUBLE, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+      if (order == 2)
+      {
+        ep_lib::MPI_Irecv(recvGrad[rank], 3*nbSendElement[rank]*(NMAX+1),
+            EP_DOUBLE, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+        nbRecvRequest++;
+        ep_lib::MPI_Irecv(recvNeighIds[rank], 4*nbSendElement[rank]*(NMAX+1), EP_INT, rank, 0, communicator, &recvRequest[nbRecvRequest]);
 //ym  --> attention taille GloId
         nbRecvRequest++;
       }
+      else
+      {
+        ep_lib::MPI_Irecv(recvNeighIds[rank], 4*nbSendElement[rank], EP_INT, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+//ym  --> attention taille GloId
+        nbRecvRequest++;
+      }
     }
   }
         
-  MPI_Waitall(nbSendRequest, sendRequest, status);
-  MPI_Waitall(nbRecvRequest, recvRequest, status);
-	
+        ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+  ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
+  
 
   /* now that all values and gradients are available use them to computed interpolated values on target
-    and also to compute weights */
+     and also to compute weights */
   int i = 0;
   for (int j = 0; j < nbElements; j++)
@@ -367,6 +369,6 @@
 
     /* since for the 2nd order case source grid elements can contribute to a destination grid element over several "paths"
-    (step1: gradient is computed using neighbours on same grid, step2: intersection uses several elements on other grid)
-    accumulate them so that there is only one final weight between two elements */
+       (step1: gradient is computed using neighbours on same grid, step2: intersection uses several elements on other grid)
+       accumulate them so that there is only one final weight between two elements */
     map<GloId,double> wgt_map;
 
@@ -380,6 +382,8 @@
       double fk = recvValue[rank][n1];
       double srcArea = recvArea[rank][n1];
+      double srcGivenArea = recvGivenArea[rank][n1];
       double w = (*it)->area;
       if (quantity) w/=srcArea ;
+      else w=w*srcGivenArea/srcArea*e.area/e.given_area ;
 
       /* first order: src value times weight (weight = supermesh area), later divide by target area */
@@ -402,5 +406,8 @@
     double renorm=0;
     if (renormalize) 
-      for (map<GloId,double>::iterator it = wgt_map.begin(); it != wgt_map.end(); it++) renorm+=it->second / e.area;
+    {
+      if (quantity) for (map<GloId,double>::iterator it = wgt_map.begin(); it != wgt_map.end(); it++) renorm+=it->second ;
+      else for (map<GloId,double>::iterator it = wgt_map.begin(); it != wgt_map.end(); it++) renorm+=it->second / e.area;
+    }
     else renorm=1. ;
 
@@ -417,6 +424,4 @@
     }
   }
-        
-        //MPI_Barrier(communicator);
 
   /* free all memory allocated in this function */
@@ -428,4 +433,5 @@
       delete[] recvValue[rank];
       delete[] recvArea[rank];
+      delete[] recvGivenArea[rank];
       if (order == 2)
       {
@@ -439,4 +445,5 @@
       delete[] sendValue[rank];
       delete[] sendArea[rank];
+      delete[] sendGivenArea[rank];
       if (order == 2)
         delete[] sendGrad[rank];
@@ -463,14 +470,14 @@
 void Mapper::computeGrads()
 {
-	/* array of pointers to collect local elements and elements received from other cpu */
-	vector<Elt*> globalElements(sstree.nbLocalElements + nbNeighbourElements);
-	int index = 0;
-	for (int i = 0; i < sstree.nbLocalElements; i++, index++)
-		globalElements[index] = &(sstree.localElements[i]);
-	for (int i = 0; i < nbNeighbourElements; i++, index++)
-		globalElements[index] = &neighbourElements[i];
-
-	update_baryc(sstree.localElements, sstree.nbLocalElements);
-	computeGradients(&globalElements[0], sstree.nbLocalElements);
+  /* array of pointers to collect local elements and elements received from other cpu */
+  vector<Elt*> globalElements(sstree.nbLocalElements + nbNeighbourElements);
+  int index = 0;
+  for (int i = 0; i < sstree.nbLocalElements; i++, index++)
+    globalElements[index] = &(sstree.localElements[i]);
+  for (int i = 0; i < nbNeighbourElements; i++, index++)
+    globalElements[index] = &neighbourElements[i];
+
+  update_baryc(sstree.localElements, sstree.nbLocalElements);
+  computeGradients(&globalElements[0], sstree.nbLocalElements);
 }
 
@@ -479,236 +486,237 @@
 void Mapper::buildMeshTopology()
 {
-	int mpiSize, mpiRank;
-	MPI_Comm_size(communicator, &mpiSize);
-	MPI_Comm_rank(communicator, &mpiRank);
-
-	vector<Node> *routingList = new vector<Node>[mpiSize];
-	vector<vector<int> > routes(sstree.localTree.leafs.size());
-
-	sstree.routeIntersections(routes, sstree.localTree.leafs);
-
-	for (int i = 0; i < routes.size(); ++i)
-		for (int k = 0; k < routes[i].size(); ++k)
-			routingList[routes[i][k]].push_back(sstree.localTree.leafs[i]);
-	routingList[mpiRank].clear();
-
-
-	CMPIRouting mpiRoute(communicator);
-	mpiRoute.init(routes);
-	int nRecv = mpiRoute.getTotalSourceElement();
-
-	int *nbSendNode = new int[mpiSize];
-	int *nbRecvNode = new int[mpiSize];
-	int *sendMessageSize = new int[mpiSize];
-	int *recvMessageSize = new int[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		nbSendNode[rank] = routingList[rank].size();
-		sendMessageSize[rank] = 0;
-		for (size_t j = 0; j < routingList[rank].size(); j++)
-		{
-			Elt *elt = (Elt *) (routingList[rank][j].data);
-			sendMessageSize[rank] += packedPolygonSize(*elt);
-		}
-	}
-
-	MPI_Alltoall(nbSendNode, 1, MPI_INT, nbRecvNode, 1, MPI_INT, communicator);
-	MPI_Alltoall(sendMessageSize, 1, MPI_INT, recvMessageSize, 1, MPI_INT, communicator);
-
-	char **sendBuffer = new char*[mpiSize];
-	char **recvBuffer = new char*[mpiSize];
-	int *pos = new int[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0) sendBuffer[rank] = new char[sendMessageSize[rank]];
-		if (nbRecvNode[rank] > 0) recvBuffer[rank] = new char[recvMessageSize[rank]];
-	}
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		pos[rank] = 0;
-		for (size_t j = 0; j < routingList[rank].size(); j++)
-		{
-			Elt *elt = (Elt *) (routingList[rank][j].data);
-			packPolygon(*elt, sendBuffer[rank], pos[rank]);
-		}
-	}
-	delete [] routingList;
-
-
-	int nbSendRequest = 0;
-	int nbRecvRequest = 0;
-	MPI_Request *sendRequest = new MPI_Request[mpiSize];
-	MPI_Request *recvRequest = new MPI_Request[mpiSize];
-	MPI_Status  *status      = new MPI_Status[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0)
-		{
-			MPI_Issend(sendBuffer[rank], sendMessageSize[rank], MPI_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-		}
-		if (nbRecvNode[rank] > 0)
-		{
-			MPI_Irecv(recvBuffer[rank], recvMessageSize[rank], MPI_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-		}
-	}
-
-	MPI_Waitall(nbRecvRequest, recvRequest, status);
-	MPI_Waitall(nbSendRequest, sendRequest, status);
-
-	for (int rank = 0; rank < mpiSize; rank++)
-		if (nbSendNode[rank] > 0) delete [] sendBuffer[rank];
-	delete [] sendBuffer;
-
-	char **sendBuffer2 = new char*[mpiSize];
-	char **recvBuffer2 = new char*[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		nbSendNode[rank] = 0;
-		sendMessageSize[rank] = 0;
-
-		if (nbRecvNode[rank] > 0)
-		{
-			set<NodePtr> neighbourList;
-			pos[rank] = 0;
-			for (int j = 0; j < nbRecvNode[rank]; j++)
-			{
-				Elt elt;
-				unpackPolygon(elt, recvBuffer[rank], pos[rank]);
-				Node node(elt.x, cptRadius(elt), &elt);
-				findNeighbour(sstree.localTree.root, &node, neighbourList);
-			}
-			nbSendNode[rank] = neighbourList.size();
-			for (set<NodePtr>::iterator it = neighbourList.begin(); it != neighbourList.end(); it++)
-			{
-				Elt *elt = (Elt *) ((*it)->data);
-				sendMessageSize[rank] += packedPolygonSize(*elt);
-			}
-
-			sendBuffer2[rank] = new char[sendMessageSize[rank]];
-			pos[rank] = 0;
-
-			for (set<NodePtr>::iterator it = neighbourList.begin(); it != neighbourList.end(); it++)
-			{
-				Elt *elt = (Elt *) ((*it)->data);
-				packPolygon(*elt, sendBuffer2[rank], pos[rank]);
-			}
-		}
-	}
-	for (int rank = 0; rank < mpiSize; rank++)
-		if (nbRecvNode[rank] > 0) delete [] recvBuffer[rank];
-	delete [] recvBuffer;
-
-
-	MPI_Barrier(communicator);
-	MPI_Alltoall(nbSendNode, 1, MPI_INT, nbRecvNode, 1, MPI_INT, communicator);
-	MPI_Alltoall(sendMessageSize, 1, MPI_INT, recvMessageSize, 1, MPI_INT, communicator);
-
-	for (int rank = 0; rank < mpiSize; rank++)
-		if (nbRecvNode[rank] > 0) recvBuffer2[rank] = new char[recvMessageSize[rank]];
-
-	nbSendRequest = 0;
-	nbRecvRequest = 0;
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0)
-		{
-			MPI_Issend(sendBuffer2[rank], sendMessageSize[rank], MPI_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-		}
-		if (nbRecvNode[rank] > 0)
-		{
-			MPI_Irecv(recvBuffer2[rank], recvMessageSize[rank], MPI_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-		}
-	}
-
-	MPI_Waitall(nbRecvRequest, recvRequest, status);
-	MPI_Waitall(nbSendRequest, sendRequest, status);
-
-	int nbNeighbourNodes = 0;
-	for (int rank = 0; rank < mpiSize; rank++)
-		nbNeighbourNodes += nbRecvNode[rank];
-
-	neighbourElements = new Elt[nbNeighbourNodes];
-	nbNeighbourElements = nbNeighbourNodes;
-
-	int index = 0;
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		pos[rank] = 0;
-		for (int j = 0; j < nbRecvNode[rank]; j++)
-		{
-			unpackPolygon(neighbourElements[index], recvBuffer2[rank], pos[rank]);
-			neighbourElements[index].id.ind = sstree.localTree.leafs.size() + index;
-			index++;
-		}
-	}
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbRecvNode[rank] > 0) delete [] recvBuffer2[rank];
-		if (nbSendNode[rank] > 0) delete [] sendBuffer2[rank];
-	}
-	delete [] recvBuffer2;
-	delete [] sendBuffer2;
-	delete [] sendMessageSize;
-	delete [] recvMessageSize;
-	delete [] nbSendNode;
-	delete [] nbRecvNode;
-	delete [] sendRequest;
-	delete [] recvRequest;
-	delete [] status;
-	delete [] pos;
-
-	/* re-compute on received elements to avoid having to send this information */
-	neighbourNodes.resize(nbNeighbourNodes);
-	setCirclesAndLinks(neighbourElements, neighbourNodes);
-	cptAllEltsGeom(neighbourElements, nbNeighbourNodes, srcGrid.pole);
-
-	/* the local SS tree must include nodes from other cpus if they are potential
+  int mpiSize, mpiRank;
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
+
+  vector<Node> *routingList = new vector<Node>[mpiSize];
+  vector<vector<int> > routes(sstree.localTree.leafs.size());
+
+  sstree.routeIntersections(routes, sstree.localTree.leafs);
+
+  for (int i = 0; i < routes.size(); ++i)
+    for (int k = 0; k < routes[i].size(); ++k)
+      routingList[routes[i][k]].push_back(sstree.localTree.leafs[i]);
+  routingList[mpiRank].clear();
+
+
+  CMPIRouting mpiRoute(communicator);
+  mpiRoute.init(routes);
+  int nRecv = mpiRoute.getTotalSourceElement();
+// cout << mpiRank << " NRECV " << nRecv << "(" << routes.size() << ")"<< endl;
+
+  int *nbSendNode = new int[mpiSize];
+  int *nbRecvNode = new int[mpiSize];
+  int *sendMessageSize = new int[mpiSize];
+  int *recvMessageSize = new int[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    nbSendNode[rank] = routingList[rank].size();
+    sendMessageSize[rank] = 0;
+    for (size_t j = 0; j < routingList[rank].size(); j++)
+    {
+      Elt *elt = (Elt *) (routingList[rank][j].data);
+      sendMessageSize[rank] += packedPolygonSize(*elt);
+    }
+  }
+
+  ep_lib::MPI_Alltoall(nbSendNode, 1, EP_INT, nbRecvNode, 1, EP_INT, communicator);
+  ep_lib::MPI_Alltoall(sendMessageSize, 1, EP_INT, recvMessageSize, 1, EP_INT, communicator);
+
+  char **sendBuffer = new char*[mpiSize];
+  char **recvBuffer = new char*[mpiSize];
+  int *pos = new int[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0) sendBuffer[rank] = new char[sendMessageSize[rank]];
+    if (nbRecvNode[rank] > 0) recvBuffer[rank] = new char[recvMessageSize[rank]];
+  }
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    pos[rank] = 0;
+    for (size_t j = 0; j < routingList[rank].size(); j++)
+    {
+      Elt *elt = (Elt *) (routingList[rank][j].data);
+      packPolygon(*elt, sendBuffer[rank], pos[rank]);
+    }
+  }
+  delete [] routingList;
+
+
+  int nbSendRequest = 0;
+  int nbRecvRequest = 0;
+  ep_lib::MPI_Request *sendRequest = new ep_lib::MPI_Request[mpiSize];
+  ep_lib::MPI_Request *recvRequest = new ep_lib::MPI_Request[mpiSize];
+  ep_lib::MPI_Status  *status      = new ep_lib::MPI_Status[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0)
+    {
+      ep_lib::MPI_Issend(sendBuffer[rank], sendMessageSize[rank], EP_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+    }
+    if (nbRecvNode[rank] > 0)
+    {
+      ep_lib::MPI_Irecv(recvBuffer[rank], recvMessageSize[rank], EP_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+    }
+  }
+
+  ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
+  ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+
+  for (int rank = 0; rank < mpiSize; rank++)
+    if (nbSendNode[rank] > 0) delete [] sendBuffer[rank];
+  delete [] sendBuffer;
+
+  char **sendBuffer2 = new char*[mpiSize];
+  char **recvBuffer2 = new char*[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    nbSendNode[rank] = 0;
+    sendMessageSize[rank] = 0;
+
+    if (nbRecvNode[rank] > 0)
+    {
+      set<NodePtr> neighbourList;
+      pos[rank] = 0;
+      for (int j = 0; j < nbRecvNode[rank]; j++)
+      {
+        Elt elt;
+        unpackPolygon(elt, recvBuffer[rank], pos[rank]);
+        Node node(elt.x, cptRadius(elt), &elt);
+        findNeighbour(sstree.localTree.root, &node, neighbourList);
+      }
+      nbSendNode[rank] = neighbourList.size();
+      for (set<NodePtr>::iterator it = neighbourList.begin(); it != neighbourList.end(); it++)
+      {
+        Elt *elt = (Elt *) ((*it)->data);
+        sendMessageSize[rank] += packedPolygonSize(*elt);
+      }
+
+      sendBuffer2[rank] = new char[sendMessageSize[rank]];
+      pos[rank] = 0;
+
+      for (set<NodePtr>::iterator it = neighbourList.begin(); it != neighbourList.end(); it++)
+      {
+        Elt *elt = (Elt *) ((*it)->data);
+        packPolygon(*elt, sendBuffer2[rank], pos[rank]);
+      }
+    }
+  }
+  for (int rank = 0; rank < mpiSize; rank++)
+    if (nbRecvNode[rank] > 0) delete [] recvBuffer[rank];
+  delete [] recvBuffer;
+
+
+  ep_lib::MPI_Barrier(communicator);
+  ep_lib::MPI_Alltoall(nbSendNode, 1, EP_INT, nbRecvNode, 1, EP_INT, communicator);
+  ep_lib::MPI_Alltoall(sendMessageSize, 1, EP_INT, recvMessageSize, 1, EP_INT, communicator);
+
+  for (int rank = 0; rank < mpiSize; rank++)
+    if (nbRecvNode[rank] > 0) recvBuffer2[rank] = new char[recvMessageSize[rank]];
+
+  nbSendRequest = 0;
+  nbRecvRequest = 0;
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0)
+    {
+      ep_lib::MPI_Issend(sendBuffer2[rank], sendMessageSize[rank], EP_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+    }
+    if (nbRecvNode[rank] > 0)
+    {
+      ep_lib::MPI_Irecv(recvBuffer2[rank], recvMessageSize[rank], EP_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+    }
+  }
+
+  ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
+  ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+
+  int nbNeighbourNodes = 0;
+  for (int rank = 0; rank < mpiSize; rank++)
+    nbNeighbourNodes += nbRecvNode[rank];
+
+  neighbourElements = new Elt[nbNeighbourNodes];
+  nbNeighbourElements = nbNeighbourNodes;
+
+  int index = 0;
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    pos[rank] = 0;
+    for (int j = 0; j < nbRecvNode[rank]; j++)
+    {
+      unpackPolygon(neighbourElements[index], recvBuffer2[rank], pos[rank]);
+      neighbourElements[index].id.ind = sstree.localTree.leafs.size() + index;
+      index++;
+    }
+  }
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbRecvNode[rank] > 0) delete [] recvBuffer2[rank];
+    if (nbSendNode[rank] > 0) delete [] sendBuffer2[rank];
+  }
+  delete [] recvBuffer2;
+  delete [] sendBuffer2;
+  delete [] sendMessageSize;
+  delete [] recvMessageSize;
+  delete [] nbSendNode;
+  delete [] nbRecvNode;
+  delete [] sendRequest;
+  delete [] recvRequest;
+  delete [] status;
+  delete [] pos;
+
+  /* re-compute on received elements to avoid having to send this information */
+  neighbourNodes.resize(nbNeighbourNodes);
+  setCirclesAndLinks(neighbourElements, neighbourNodes);
+  cptAllEltsGeom(neighbourElements, nbNeighbourNodes, srcGrid.pole);
+
+  /* the local SS tree must include nodes from other cpus if they are potential
            intersector of a local node */
-	sstree.localTree.insertNodes(neighbourNodes);
-
-	/* for every local element,
+  sstree.localTree.insertNodes(neighbourNodes);
+
+  /* for every local element,
            use the SS-tree to find all elements (including neighbourElements)
            who are potential neighbours because their circles intersect,
-	   then check all canditates for common edges to build up connectivity information
-	*/
-	for (int j = 0; j < sstree.localTree.leafs.size(); j++)
-	{
-		Node& node = sstree.localTree.leafs[j];
-
-		/* find all leafs whoes circles that intersect node's circle and save into node->intersectors */
-		node.search(sstree.localTree.root);
-
-		Elt *elt = (Elt *)(node.data);
-
-		for (int i = 0; i < elt->n; i++) elt->neighbour[i] = NOT_FOUND;
-
-		/* for element `elt` loop through all nodes in the SS-tree
+     then check all canditates for common edges to build up connectivity information
+  */
+  for (int j = 0; j < sstree.localTree.leafs.size(); j++)
+  {
+    Node& node = sstree.localTree.leafs[j];
+
+    /* find all leafs whoes circles that intersect node's circle and save into node->intersectors */
+    node.search(sstree.localTree.root);
+
+    Elt *elt = (Elt *)(node.data);
+
+    for (int i = 0; i < elt->n; i++) elt->neighbour[i] = NOT_FOUND;
+
+    /* for element `elt` loop through all nodes in the SS-tree
                    whoes circles intersect with the circle around `elt` (the SS intersectors)
                    and check if they are neighbours in the sense that the two elements share an edge.
                    If they do, save this information for elt */
-		for (list<NodePtr>::iterator it = (node.intersectors).begin(); it != (node.intersectors).end(); ++it)
-		{
-			Elt *elt2 = (Elt *)((*it)->data);
-			set_neighbour(*elt, *elt2);
-		}
+    for (list<NodePtr>::iterator it = (node.intersectors).begin(); it != (node.intersectors).end(); ++it)
+    {
+      Elt *elt2 = (Elt *)((*it)->data);
+      set_neighbour(*elt, *elt2);
+    }
 
 /*
-		for (int i = 0; i < elt->n; i++)
-		{
-			if (elt->neighbour[i] == NOT_FOUND)
-				error_exit("neighbour not found");
-		}
+    for (int i = 0; i < elt->n; i++)
+    {
+      if (elt->neighbour[i] == NOT_FOUND)
+        error_exit("neighbour not found");
+    }
 */
-	}
+  }
 }
 
